package com.saga.flink.cdc.app;

import com.alibaba.fastjson.JSONObject;
import com.saga.flink.cdc.bean.User;
import com.saga.flink.cdc.sink.PhoenixSinkFunction;
import com.saga.flink.cdc.source.JSONDebeziumDeserializationSchema;
import com.ververica.cdc.connectors.mysql.MySqlSource;
import com.ververica.cdc.connectors.mysql.table.StartupOptions;
import com.ververica.cdc.debezium.DebeziumSourceFunction;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;

public class FlinkPhoenixDML {

    public static void main(String[] args) {

        StreamExecutionEnvironment env = StreamExecutionEnvironment.getExecutionEnvironment();

        env.setParallelism(3);
        DebeziumSourceFunction<JSONObject> mysqlSource = MySqlSource.<JSONObject>builder()
                .hostname("hadoop01")
                .port(3306)
                .username("root")
                .password("j5ry0#jZ7vaUt5f4")
                .databaseList("saga_dev")
                .tableList("saga_dev.user") //可选配置项,如果不指定该参数,则会读取上一个配置下的所有表的数据，注意：指定的时候需要使用"db.table"的方式
                .startupOptions(StartupOptions.initial())
                .deserializer(new JSONDebeziumDeserializationSchema())
                .build();

        DataStreamSource<JSONObject> userDataStreamSource = env.addSource(mysqlSource);
        userDataStreamSource.returns(JSONObject.class).addSink(new PhoenixSinkFunction<>());

        try {
            env.execute("DML");
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            env.execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
