package com.saga.flink.cdc.source;

import com.alibaba.fastjson.JSONObject;
import com.saga.flink.cdc.utils.CDCUtils;
import com.ververica.cdc.debezium.DebeziumDeserializationSchema;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.util.Collector;
import org.apache.kafka.connect.source.SourceRecord;

public class JSONDebeziumDeserializationSchema implements DebeziumDeserializationSchema<JSONObject> {
    @Override
    public void deserialize(SourceRecord sourceRecord, Collector<JSONObject> collector) throws Exception {

        JSONObject cdcDataJSON = CDCUtils.getCDCDataJSON(sourceRecord);
        collector.collect(cdcDataJSON);
    }

    @Override
    public TypeInformation<JSONObject> getProducedType() {
        return null;
    }
}
